c	AbiPrintOut.For
c
c	15-AUG-2000 David Mathog, Biology Division, Caltech
c	  added #q>= 20: xxx, 30: xxx, 40: xxx, 50: xxx  to output (general
c	  quality measure, over WHOLE sequence)
c	08-AUG-2000 David Mathog, Biology Division, Caltech
C	  used the fortran code from "abibreakout2.for" instead
C	  of the C code from Ted to extract data from the chromatogram
C	  file.  Added /NOVel, if set, new flag fields are displayed
C	  in the output.  (ABI adds them from time to time.)
C	  Moved routines from FTR_UTILS into this file so that this
C	  program no longer requires linking to that object library.
C	  However, because the ABI routines use IEEE float, and the GCG
C	  libraries use the default VMS float, they can't both be
C	  in the same file.  So build it like:
C
C	    $ gcgsupport 
C	    $ fortran/old/extend/nolis/warn abiprintout
C	    $ fortran/old/extend/nolis/float=ieee/warn abi_utils
C	    $ sharelink abiprintout,abi_utils
C
C	  This works because getabifortran passes the floating point
C	  values out as strings only.
C
C	  Added /note="blah", which puts another comment line in with
C         a person's name (or any other small snippet of information.)
C
c	26-JUL-2000 David Mathog, Biology Division, Caltech
c	  added /phd=, which uses the bases called by phred
c	  and also prints qual information and different header
c	  information.
c
c	11-FEB-1999 David Mathog, Biology Division, Caltech
c	  added /FIT, which plots the range specified in a single
c	  panel.
c
c	21-FEB-1995 David Mathog, Biology Division, Caltech
c	This uses GCG graphics to format an entire ABI trace.
c	If color is available, great, but since it often isn't
c	(as on a laserprinter) this shows the order of the traces
c	with letters underneath.  If two traces are within 5% of the
c	height of the largest trace they are shown in lower case.
C
C
C compile like:   fortran/old/extend/nolis/warn=all/float=ieee abiprintout2
C
c
c
	implicit none
	Include 'GenInclude:SYSCOnstants.inc'
	integer*4 maxpoints,maxBases,maxinfo,maxinfotypes
	parameter (maxpoints = 32000)
	parameter (maxbases  = 4000)
	parameter (maxinfo   = 64)
	parameter (maxinfotypes   = 64)
c
c	stuff to retrieve from ABI file
C	watch out! Traces are all in UNSIGNED integer*2
c
	integer*4 Npoints,NorigBases
	integer*4 begin,end
	integer*2 maxTraceVal
	integer*2 tC(maxpoints),tA(maxpoints)
	integer*2 tG(maxpoints),tT(maxpoints)
	character*1 bases(maxbases)
	character*1 info(maxinfo,maxinfotypes)
	integer*2   basepos(maxbases)
	integer*4   qual(maxbases)
c
	character*1 filename(255)
	character*1 phdfilename(255)
	character*1 note(255)
	character*1 tlabel(2000)
	integer*4 inslot,ppages
	integer*4 status,temp
	integer*4 i
	character*1 inline(256)
	logical   fit
	logical	  phd,shownovel
	integer*4 phdstate,phdcount
	integer*4 phdfile
	character*1 abase
	integer*4   aqual
	integer*2   aposition
c
	logical CLGetStr, GetString, CLNoInteract, CLGetInt, GetInt, CLGetBool
	logical OpenFile
	integer StrCompare, SReadF, ReadString, MyStrCompare
c
c
c
c
	Call GCGInit('AbiPrintOut')
	Call Doc()
        Call CLComCheck()
c
        If ( .not. CLGetStr('INfile', filename)  ) Then
          If ( .not.CLNoInteract() ) then
	    Call WriteF('\nAbiPrintOut of what trace?')
	    If ( GetString(filename).eq.0 ) Stop ' '
	  else
	    stop 'AbiPrintOut fatal error - no input file!'
	  End If
        End If ! Block created by IfAnd for UNIX
c
C
	phd = .false.
        If ( CLGetStr('PHDfile', phdfilename)  ) Then
	   phd = .true.
	endif
	shownovel=.false.
	call ClGetBool('NOVel',shownovel)
C
C
	call getabifortran(
	1 filename,
	1 npoints,
	1 norigbases,
	1 maxTraceVal,
	1 tC, tA, tG, tT,
	1 bases,
	1 basePos,
	1 maxpoints, maxbases,
	1 info,
	1 maxinfo,maxinfotypes,
	1 phd, shownovel)
	
c
	inslot = 1000
	if(.not. CLGetInt('PNTperline', 1,maxpoints,inslot))then
	Do while(inslot.lt.1 .or. inslot .gt. maxpoints)
          If ( .not.CLNoInteract() ) then
	    Call WriteF(
	1   '\n Enter the number of points per line (1 to %d,inclusive)'
	1   ,MAXpoints)
	    Call GetInt(inslot)
	  else
	    Call WriteF('\n Defaulting to 1000 points/line) ')
	    inslot = 1000
	  end if
	end do
	end if

	fit=.false.
	call ClGetBool('FIT',fit)
c
c	ppages is the maximum number of pages to print.  It can
c	be used instead of /begin/end to restrict the amount of
c	pages printed.
c	
	if(.not. CLGetInt('PAGes', 1,1000,ppages))then
	  ppages = 1000
	end if
	
c
c	if a phd file is specified replace the base type and position 
c	information with that from the file.  Also retain the comment and
c	quality information.
c
c
        If ( phd ) Then
	   call OpenFile(phdfile,phdfilename,'r')
	   phdstate=0
	   phdcount=0
	   norigbases=0
	   do while(status .ge. 0)
	     status=ReadString(phdfile,inline,temp)
	     if(status .ge. 0)then
	         if(phdstate .eq. 0)then       ! searching for BEGIN_COMMENT
	           if(0 .eq. StrCompare(inline,'BEGIN_COMMENT'//char(0)))phdstate=1
	         else if(phdstate .eq. 1)then  ! waiting   for END_COMMENT
	           if(0 .eq. StrCompare(inline,'END_COMMENT'//char(0)))then
		     phdstate=2
		   else if(0 .eq. MyStrCompare(inline,'CHROMAT_FILE:'//char(0),':'))then
		     call StrConcat(info(1,4),inline)
		   else if(0 .eq. MyStrCompare(inline,'PHRED_VERSION:'//char(0),':'))then
		     call StrConcat(info(1,2),inline)
		   end if
	         else if(phdstate .eq. 2)then  ! waiting   for BEGIN_DNA
	           if(0 .eq. StrCompare(inline,'BEGIN_DNA'//char(0)))phdstate=3
	         else if(phdstate .eq. 3)then  ! waiting   for END_DNA
	           if(0 .eq. StrCompare(inline,'END_DNA'//char(0)))then
		     phdstate=4
		   else
	             temp=SReadF(inline,'%c %d %d',abase,aqual,aposition)
	             if(temp .eq. 3)then
	             	phdcount = phdcount + 1
	             	bases(phdcount)=abase
	             	qual(phdcount)=aqual
	             	basepos(phdcount)=aposition
	             else ! this would be an error, but exit ok with it
	             	NOrigBases=phdcount
	             	call Closef(phdfile)
	             	status=-1
	             end if
		   end if
	         else if(phdstate .eq. 4)then  ! all done
	           status = -1
	           NOrigBases=phdcount
	           call Closef(phdfile)
	         end if
	     end if
	   end do
	   bases(phdcount+1)=char(0)  ! be sure to terminate here
        End If ! Block created by IfAnd for UNIX
C
C	it's possible for PHRED to screw up and emit an empty
C	PHD file.  Similarly, ABI files can be invalid.  When either
C	happens ABIPRINTOUT has to detect it here and terminate.
C
	if(NorigBases .le. 5)then
	   Call WriteF('Invalid trace file - no bases found!\n')
	   call GCGexit(EXITBAD)
	end if
c
	begin = 1
	if(.not. CLGetInt('BEGin', 1,NorigBases,begin))then
	Do while(begin.lt.1 .or. begin .gt. NorigBases)
          If ( .not.CLNoInteract() ) then
	    Call WriteF(
	1   '\n Enter the first base to show (1 to %d,inclusive)'
	1   ,NorigBases)
	    Call GetInt(begin)
	  else
	    Call WriteF('\n Defaulting to begin = 1) ')
	    begin = 1
	  end if
	end do
	end if
c
	end = NorigBases
	if(.not. CLGetInt('END', 1,NorigBases,end))then
	Do while(end.lt.1 .or. end .gt. NorigBases)
          If ( .not.CLNoInteract() ) then
	    Call WriteF(
	1   '\n Enter the first base to show (1 to %d,inclusive)'
	1   ,NorigBases)
	  else
	    Call WriteF('\n Defaulting to End = %d ',NorigBases)
	    begin = 11
	  end if
	end do
	end if
c
c
!	call abi_plotall(NPoints,NorigBases,maxTraceVal,inslot,
!	1 tC,tA,tG,tT,basepos,filename)
c
c	take the information in the first 10 slots of info() and
c	format them into a single tlabel record.  The format is 3 columns
C	of width 64 each, followed by char(10) (line feed)	
c
        If ( CLGetStr('NOTe', note)  ) Then
	  call StrConcat(info(1,11),'note: '//char(0)  )
	  call StrConcat(info(1,11),note)
	endif
	do i=1,12
	  call spacesto(info(1,i),64)
	end do
	call StrConcat(tlabel,info(1,1))          ! MCHN
	call StrConcat(tlabel,info(1,5))          ! PDMF
	call StrConcat(tlabel,info(1,9))          ! start time
	call StrConcat(tlabel,char(10)//char(0))  ! lf
	call StrConcat(tlabel,info(1,2))          ! PHRED version
	call StrConcat(tlabel,info(1,6))          ! Tube/lane
	call StrConcat(tlabel,info(1,10))         ! stop time
	call StrConcat(tlabel,char(10)//char(0))  ! lf
	call StrConcat(tlabel,info(1,3))          ! SMPL
	call StrConcat(tlabel,info(1,7))          ! Space
	call StrConcat(tlabel,info(1,11))         ! comment (optional)
	call StrConcat(tlabel,char(10)//char(0))  ! lf
	call StrConcat(tlabel,info(1,4))          ! file
	call StrConcat(tlabel,info(1,8))          ! SCAN
	if(phd)then
	  call calcq2030(info(1,12),qual,Norigbases)
	  call StrConcat(tlabel,info(1,12))         ! comment (optional)
	end if
c

	begin = basepos(begin) - 5
	if(begin .lt. 1)begin = 1
	end = basepos(end) + 5
	if(end .gt. Npoints)end = Npoints
	if(fit)inslot = end - begin + 1
	if(phd)then
           call StrToUpper(bases)
 	   call abi_plotallq(NPoints,NorigBases,maxTraceVal,
	1  inslot,tC,tA,tG,tT,basepos,begin,end,bases,
	1  qual,tlabel,ppages)
        else
           call abi_plotall(NPoints,NorigBases,maxTraceVal,
	1  inslot,tC,tA,tG,tT,basepos,begin,end,
	1  tlabel,ppages)
        end if

        Call Account()  !it needs this to pick up 
	call GCGexit(EXITGOOD)
	stop
	end
        
c
c	compares two strings up to a null terminator or
c	the character "c", if it occurs in S1.  Returns
c	0 for a match
c
c
	integer function MyStrCompare(s1,s2,c)
	character*1 s1(*),s2(*),c
	integer i
c
	MyStrCompare=0
	i=1
	do while(i .lt. 100000)  ! more than enough for these purposes
	  if(s1(i) .eq. c)then
	    return
	  else if(s1(i) .lt. s2(i))then
	    MyStrCompare=-1
	    return
	  else if(s1(i) .gt. s2(i))then
	    MyStrCompare=1
	    return
	  else if(s1(i) .eq. char(0))then !and  s1=s2
	    return
	  end if
	  i = i + 1
	end do
	return
	end
C
C	**************************************************************	
C	routines from FTR_UTILS.FOR
C
c	These are an assortment of routines for plotting/manipulating
c	traces derived from ABI trace files.
c
c
	subroutine abi_plotit(NPoints,NorigBases,maxTraceVal,
	1 leftcutoff,rightcutoff,
	1 tC,tA,tG,tT,basepos)
c
	implicit none
	integer*4 Npoints,NorigBases
	integer*4 leftcutoff, rightcutoff
c
	integer*2 maxTraceVal
	integer*2 tC(Npoints),tA(Npoints),tG(Npoints),tT(Npoints)
c
	integer*2 basepos(NorigBases)
c
	real*4  xl,xu,yl,yu,refV
	real*4  x,y
	character*1 passc(2)
	character*1 torder(4)
	integer*4 i,j,temp
	integer*2 zeroline(2)
c
	call WPlotBegin()
	call WPlotInit()

	xl = float(leftcutoff)
	xu = float(rightcutoff)
	refV = float(maxTraceVal)
	yl = -0.1 * refV
	yu =  1.1 * refV 
        Call WViewPort(2.0, 148.0, 90.0, 100.0)
        Call WWindow(  xl, xu, 0.0, 1.0)
        Call TickAxis(.true.)
c
c	put the title across the top
c
        Call WMoveTo((xl+xu)/2.,0.5)
        Call WTextOrg(5)
        Call WPlotf('Test Trace Output\n')

c
C	now draw the letters.  Use mode "8" because the ABI
c	position seems to be slightly off center
C
        Call WViewPort(2.0, 148.0, 0.0, 10.0)
        Call WWindow(  xl, xu, 0.0, 1.0)
	Call WTextOrg(5)
	call WCHeight(1.5)
	call WNewColor(1)
	passc(2) = char(0)
	do i = 1,Norigbases
	  temp = basepos(i) + 1 !C starts 0, fortran at 1
	  if(temp .ge. leftcutoff)then
	  if(temp .le. rightcutoff)then
	    x = temp
	    call abi_baseorder(torder,tc,ta,tg,tt,npoints,temp)
	    y = .8
	    do j = 1,4
	      call WNewColor(j)
	      call Wmoveto(x,y)
	      passc(1)=torder(j)
	      call WPlotF('%s\n',passc)
	      y = y -.2
	      call wcheight(1.0)
	    end do
	    call wcheight(1.5)
	    call WNewColor(1)
	  end if
	  end if
	end do


	call WNewColor(3)
	call abi_putpanel(tC,Npoints,leftcutoff,rightcutoff,10.0,30.0,refV)
	call WNewColor(2)
	call abi_putpanel(tA,Npoints,leftcutoff,rightcutoff,10.0,30.0,refV)
	call WNewColor(1)
	call abi_putpanel(tG,Npoints,leftcutoff,rightcutoff,10.0,30.0,refV)
	call WNewColor(4)
	call abi_putpanel(tT,Npoints,leftcutoff,rightcutoff,10.0,30.0,refV)
c	draw the baseline
	call WNewColor(1)
	call abi_putpanel(zeroline,2,leftcutoff,rightcutoff,10.0,30.0,refV)
c
	call WPlotExit()
	call WPlotEnd()
	return
	end


	subroutine abi_putpanel(val,points,leftcutoff,rightcutoff
	1  ,yl,yu,refV)
	implicit none
	integer*4 points,leftcutoff,rightcutoff
	real*4    yl,yu,refV
	integer*2 val(points)
c
	real*4    xl,xu,x,y
	integer*4 i
c
        Call WViewPort(2.0, 148.0, yl, yu)
	xl = float(leftcutoff)
	xu = float(rightcutoff)
        Call WWindow(  xl, xu, 0.0, refV)
	
	x = leftcutoff
	y = val(leftcutoff)
	Call WMoveTo(x,y)
	i = leftcutoff
	do while(i .le. rightcutoff .and. i .le. points)
	  x = i
	  y = val(i)
	  Call WDraw(x,y)
	  i = i + 1
	end do
	return
	end

	subroutine abi_putbaseline(leftcutoff,rightcutoff,yl,yu)
	implicit none
	integer*4 leftcutoff,rightcutoff
	real*4    yl,yu
c
        Call WViewPort(2.0, 148.0, yl, yu)
        Call WWindow(  float(leftcutoff),float(rightcutoff), 0.0, 1.0)
	Call WMoveTo(float(leftcutoff),0.0)
	Call WDraw(float(rightcutoff),0.0)
	return
	end
C
C	return the base order highest, to lowest, in torder.
C	If there is a tie (within 5% of peak height) the characters come back in
C	lower case.  If there is an exact tie, the order is arbitrary.
C
	subroutine abi_baseorder(torder,tc,ta,tg,tt,npoints,this)
	implicit none
	integer*4 npoints,this
	integer*2 tC(npoints),tA(npoints),tG(npoints),tT(npoints)
	character*1 torder(4)
c
	structure /pair/
	  integer*4    val
	  character*1  base
	  character*1  altbase
	end structure

	record /pair/ sortem(4),scratch
	integer*4 i,j
c
c	offset value by 1 to avoid division by zero and other nonsense
c
	sortem(1).val = tC(this) + 1
	sortem(2).val = tA(this) + 1
	sortem(3).val = tG(this) + 1
	sortem(4).val = tT(this) + 1
	sortem(1).base = 'C'
	sortem(2).base = 'A'
	sortem(3).base = 'G'
	sortem(4).base = 'T'
	sortem(1).altbase = 'c'
	sortem(2).altbase = 'a'
	sortem(3).altbase = 'g'
	sortem(4).altbase = 't'
c
c	use bubble sort - there are only 4 of them
c
	do i = 4,2,-1
	do j = 2,i
	  if(sortem(j-1).val .lt. sortem(j).val)then
	     scratch     = sortem(j)
	     sortem(j)   = sortem(j-1)
	     sortem(j-1) = scratch	    
	  end if
	end do
	end do
c
c	If the difference between any two traces is <= 5% of the peak 
c	height they are both shown in lower case.
c
	do i = 1,3
	   if(
	1      float(  sortem(i).val - sortem(i+1).val )
	1                         /
	1               float(sortem(1).val)
	1                       .lt.
	1                       0.05
	1     )then
	      sortem(i).base = sortem(i).altbase
	      sortem(i+1).base = sortem(i+1).altbase
	   end if
	end do
c
	do i = 1,4
	   torder(i) = sortem(i).base
	end do
c
	return
	end




	subroutine abi_plotall(NPoints,NorigBases,maxTraceVal,
	1 inslot,tC,tA,tG,tT,basepos,begin,end,
	1 tlabel,ppages)
c
	implicit none
	integer*4 Npoints,NorigBases,begin,end
	integer*4 inslot,ppages
c
	integer*2 maxTraceVal
	integer*2 tC(Npoints),tA(Npoints),tG(Npoints),tT(Npoints)
	character*1 tlabel(*)
c
	integer*2 basepos(NorigBases)
c
	integer*4 leftcutoff, rightcutoff
	real*4  yl,yu,refV
	integer*4 j,page
	real*4 pyl,pyu
	real*4 ty
	integer*4 ts,i
c
c	The vertical page layout is this:
c	96 <-> 100 header
c	4 stripes of size 96/4 = 24, top 18 for trace, bottom 6 for letters
c	Of those 6, split into 5 stripes, top one is position (every 10th)
c	and bottom 4 are the bases
c
	call WPlotBegin()

	leftcutoff = begin
	rightcutoff = leftcutoff + inslot - 1

	refV = float(maxTraceVal)
	yl = -0.1 * refV
	yu =  1.1 * refV 
c
	page = 1
	do while (leftcutoff .lt. end .and. page .le. ppages)
C
C	set the linewidth to the smallest possible - this only works on
C	some drivers, postscript in particular.  Has to be done
c	for each page new page
C
	call WPlotInit()
	call WLineWidth(0.00001)
	call Wmoveto(3.0,99.0)
	call WFont(0)          ! use hardware font by default, if that is supported
	call WCHeight(1.0)
        call WtextOrg(2)  ! left justified
C
C	tlabel contains a set of LF (char10) delimited fields.  Emit
C	them one at a time until all are out.
C
	ty=99.0
	ts=1
	i=1
	call Wmoveto(140.0,ty)
	call WPlotF('Page: %d\n',page)
c
	call Wmoveto(3.0,ty)
	do while(tlabel(i) .ne. char(0))
	  if(tlabel(i) .eq. char(10))then
	    tlabel(i)=char(0)
	    call WPlotF('%s\n',tlabel(ts))
	    tlabel(i)=char(10)
	    ty=ty - 1.3
	    call Wmoveto(3.0,ty)
	    ts = i + 1
	  endif
	  i = i + 1
	end do
	call WPlotF('%s\n',tlabel(ts))
C
        call WtextOrg(5)  ! centered
	page = page + 1

	j = 96
	do while (leftcutoff .lt. end .and. j .ge. 24)
	pyu = j
	pyl = j-17
c
	call WNewColor(3)
	call abi_putpanel(tC,end,leftcutoff,rightcutoff,pyl,pyu,refV)
	call WNewColor(2)
	call abi_putpanel(tA,end,leftcutoff,rightcutoff,pyl,pyu,refV)
	call WNewColor(1)
	call abi_putpanel(tG,end,leftcutoff,rightcutoff,pyl,pyu,refV)
	call WNewColor(4)
	call abi_putpanel(tT,end,leftcutoff,rightcutoff,pyl,pyu,refV)
c	draw the baseline
	call WNewColor(1)
	call abi_putbaseline(leftcutoff,rightcutoff,pyl,pyu)
c
	pyl = pyl - 6.0
	pyu = pyl + 5.0
	call abi_labelpanel(end,norigbases,tc,ta,tg,tt
	1  ,basepos,leftcutoff,rightcutoff,pyl,pyu)
c
	leftcutoff = leftcutoff + inslot
	rightcutoff = rightcutoff + inslot
	j = j - 24
	end do
	call WPlotExit()
	end do
c
	call WPlotEnd()
	return
	end

	subroutine abi_plotallq(NPoints,NorigBases,maxTraceVal,
	1 inslot,tC,tA,tG,tT,basepos,begin,end,bases,
	1 qual,tlabel,ppages)
c
	implicit none
	integer*4 Npoints,NorigBases,begin,end
	integer*4 inslot,ppages
c
	integer*2 maxTraceVal
	integer*2 tC(Npoints),tA(Npoints),tG(Npoints),tT(Npoints)
c
	integer*2 basepos(NorigBases)
	integer*4 qual(NorigBases)
	character*1 tlabel(*)
	character*1 bases(NorigBases)
c
	integer*4 leftcutoff, rightcutoff
	real*4  yl,yu,refV
	integer*4 j,page
	real*4 pyl,pyu
	real*4 ty
	integer*4 ts,i
c
c	The vertical page layout is this:
c	92 <-> 100 header
c	5 stripes of size 90/5 = 18, top 14 for trace, bottom 4 for letters
c	Of those 4, top one is position (every 10th), second is base,
c	and bottom 2 is the qual
c
	call WPlotBegin()

	leftcutoff = begin
	rightcutoff = leftcutoff + inslot - 1

	refV = float(maxTraceVal)
	yl = -0.1 * refV
	yu =  1.1 * refV 
c
	page = 1
	do while (leftcutoff .lt. end .and. page .le. ppages)
C
C	set the linewidth to the smallest possible - this only works on
C	some drivers, postscript in particular.  Has to be done
c	for each page new page
C
	call WPlotInit()
	call WLineWidth(0.00001)
	call Wmoveto(3.0,99.0)
	call WFont(0)          ! use hardware font by default, if that is supported
	call WCHeight(1.0)
        call WtextOrg(2)  ! left justified
C
C	tlabel contains a set of LF (char10) delimited fields.  Emit
C	them one at a time until all are out.
C
	ty=99.0
	ts=1
	i=1
	call Wmoveto(140.0,ty)
	call WPlotF('Page: %d\n',page)
c
	call Wmoveto(3.0,ty)
	do while(tlabel(i) .ne. char(0))
	  if(tlabel(i) .eq. char(10))then
	    tlabel(i)=char(0)
	    call WPlotF('%s\n',tlabel(ts))
	    tlabel(i)=char(10)
	    ty=ty - 1.3
	    call Wmoveto(3.0,ty)
	    ts = i + 1
	  endif
	  i = i + 1
	end do
	call WPlotF('%s\n',tlabel(ts))
C
        call WtextOrg(5)  ! centered
	page = page + 1

	j = 92
	do while (leftcutoff .lt. end .and. j .ge. 18)
	pyu = j
	pyl = j-14
c
	call WNewColor(3)
	call abi_putpanel(tC,end,leftcutoff,rightcutoff,pyl,pyu,refV)
	call WNewColor(2)
	call abi_putpanel(tA,end,leftcutoff,rightcutoff,pyl,pyu,refV)
	call WNewColor(1)
	call abi_putpanel(tG,end,leftcutoff,rightcutoff,pyl,pyu,refV)
	call WNewColor(4)
	call abi_putpanel(tT,end,leftcutoff,rightcutoff,pyl,pyu,refV)
c	draw the baseline
	call WNewColor(1)
	call abi_putbaseline(leftcutoff,rightcutoff,pyl,pyu)
c
	pyl = pyl - 4.0
	pyu = pyl + 3.0
	call abi_labelpanelq(end,norigbases,basepos,leftcutoff,
	1  rightcutoff,pyl,pyu,bases,qual)
c
	leftcutoff = leftcutoff + inslot
	rightcutoff = rightcutoff + inslot
	j = j - 18
	end do
	call WPlotExit()
	end do
c
	call WPlotEnd()
	return
	end

c
c	The format of the label is:
c
c	position        size    what
c	1               small   baseposition (every tenth)
c	2               big     base at peak
c	3               small   first base under peak
c	4               small   second base under peak
c	5               small   third base under peak
c
	subroutine abi_labelpanel(npoints,norigbases,tc,ta,tg,tt
	1  ,basepos,leftcutoff,rightcutoff,yl,yu)
	implicit none
	integer*4 Npoints,NorigBases
	integer*2 tC(Npoints),tA(Npoints),tG(Npoints),tT(Npoints)
	integer*2 basepos(NorigBases)
	real*4 yl,yu
	integer*4 leftcutoff,rightcutoff
c
	real*4 x,y,bigchar,littlechar,space
	integer bigline
	parameter (bigline = 200)
	character*1 torder(4,bigline)
	integer*2   xout(bigline)
	character*1 passc(2),gstring(33)
	integer     temp,i,j,count

        Call WViewPort(2.0, 148.0, yl, yu)
        Call WWindow(  float(leftcutoff), float(rightcutoff), 0.0, 1.0)
	Call WTextOrg(5)
	passc(2) = char(0)
c
c	do this in two passes, for speed.  By preprocessing a lot of the
c	information the character size and color changes can be greatly 
c	reduced, which speeds up the output a lot.
C
c	first fill the torder array with sorted peak heights.  
c	simultaneously, put out any base position labels
c
	space      = (yu - yl)/5.5
	littlechar = 0.9 * space
	bigchar    = 1.5 * littlechar
	space      = 1.0/5.5
	y          = 1.0 - 0.4 * space
	call WCHeight(littlechar)
c
	count = 0
	do i = 1,Norigbases
	  temp = basepos(i) + 1 !C starts 0, fortran at 1
	  if(temp .ge. leftcutoff)then
	  if(temp .le. rightcutoff)then
	  if(temp .le. npoints)then
	    count = count + 1
	    if(count .gt. bigline)then
	      write(6,*)'Fatal error, attempt to put >',bigline
	1      ,' bases on one line'
	      stop ' '
	    end if
	    x = temp
	    xout(count)=x
	    call abi_baseorder(torder(1,count),tc,ta,tg,tt,npoints,temp)
	    if(jmod(i,10).eq.0)then
	        call IntToStr(i,gstring)
	        call Wmoveto(x,y)
	        call WPlotF('%s\n',gstring)
	    end if
	  end if
	  end if
	  end if
	end do
c
c	second pass.  Do 4 runs through, each time outputting the jth
c	highest peak's character
c
	do j = 1, 4
	   if(j .eq. 1)then
	     call WCHeight(bigchar)
	     call WNewColor(1)
	     y = 1.0 - space * 1.75
	   else if(j.eq.2)then
	     call WCHeight(littlechar)
	     y = 1.0 - space * 3.0
	   else
	     y = y - space
	   end if
	   do i = 1,count
	     x = xout(i)
	     call Wmoveto(x,y)
	     passc(1)=torder(j,i)
	     call WPlotF('%s\n',passc)
	   end do
	end do
c
	call wcheight(1.5)
	return
	end
c
c	The format of the label is:
c
c	position        size    what
c	1               small   baseposition (every tenth)
c	2               big     base at peak
c	3               small   first digit of qual
c	4               small   second digit of qual
c
	subroutine abi_labelpanelq(npoints,norigbases,
	1  basepos,leftcutoff,rightcutoff,yl,yu,bases,qual)
	implicit none
	integer*4 Npoints,NorigBases
	integer*2 basepos(NorigBases)
	integer*4 qual(NorigBases)
	character*1 bases(NorigBases)
	real*4 yl,yu
	integer*4 leftcutoff,rightcutoff
c
	real*4 x,y,bigchar,littlechar,space
	integer bigline
	parameter (bigline = 200)
	character*1 passc(2),gstring(33),pass3(3)
	integer     temp,i,count

        Call WViewPort(2.0, 148.0, yl, yu)
        Call WWindow(  float(leftcutoff), float(rightcutoff), 0.0, 1.0)
	Call WTextOrg(5)
	passc(2) = char(0)
	pass3(3) = char(0)
c
c	do this in two passes, for speed.  By preprocessing a lot of the
c	information the character size and color changes can be greatly 
c	reduced, which speeds up the output a lot.
C
c
	space      = (yu - yl)/3.5
	littlechar = 0.9 * space
	bigchar    = 1.5 * littlechar
	space      = 1.0/3.5
	call WCHeight(littlechar)
c
c	write the position information
c
	count = 0
	do i = 1,Norigbases
	  y = 1.0 - 0.1 * space
	  temp = basepos(i) + 1 !C starts 0, fortran at 1
	  if(temp .ge. leftcutoff)then
	  if(temp .le. rightcutoff)then
	  if(temp .le. npoints)then
	    count = count + 1
	    if(count .gt. bigline)then
	      write(6,*)'Fatal error, attempt to put >',bigline
	1      ,' bases on one line'
	      stop ' '
	    end if
	    x = temp + 1 ! needs an extra offset of 1, not quite sure why...
	    if(jmod(i,10).eq.0)then
	        call IntToStr(i,gstring)
	        call Wmoveto(x,y)
	        call WPlotF('%s\n',gstring)
	    end if
c
c	output the base
c
	    call WCHeight(bigchar)
	    if(bases(i) .eq. 'C')call WNewColor(3)
	    if(bases(i) .eq. 'A')call WNewColor(2)
	    if(bases(i) .eq. 'G')call WNewColor(1)
	    if(bases(i) .eq. 'T')call WNewColor(4)
	    y = 1.0 - space * 1.5
	    call Wmoveto(x,y)
	    passc(1)=bases(i)
	    call WPlotF('%s\n',passc)
c
c	output the qual value
c
	     call WCHeight(littlechar)
	     call WNewColor(1)
	     y = 1.0 - space * 2.95
	     call SWriteF(pass3,'%.2d',qual(i))
	     call Wmoveto(x,y)
	     call WTextDir(270.0)
	     call WPlotF('%s\n',pass3)
	     call WTextDir(0.0)
c	draw a point under the peak
	     call WPoint(x,1.0 + 0.75 * space)
	  end if
	  end if
	  end if
	end do
c
	call wcheight(1.5)
	return
	end

	subroutine abi_putheader(gstring)
	implicit none
	character*1 gstring(1)
c
        Call WViewPort(2.0, 148.0, 96.0, 100.0)
        Call WWindow(  0.0, 1.0, 0.0, 1.0)
c
c	put the title across the top
c
        Call WMoveTo(0.5,0.5)
        Call WTextOrg(5)
        Call WPlotf('%s\n',gstring)
	return
	end

	subroutine calcq2030(string,qual,N)
	implicit none
	character*1 string(*)
	integer*4 N,qual(N)
C
	integer*4 q20,q30,q40,q50,i
C
	q20=0
	q30=0
	q40=0
	q50=0
	do i = 1, N
	  if(qual(i) .ge. 20)then
	     q20 = q20 + 1
	     if(qual(i) .ge. 30)then
	       q30 = q30 + 1
	       if(qual(i) .ge. 40)then
	         q40 = q40 + 1
	         if(qual(i) .ge. 50)then
	           q50 = q50 + 1
	         end if
	       end if
	     end if
	  end if
	end do
C
	call SWriteF(string,'#q>= 20: %.3d, 30: %.3d,  40: %.3d, 50: %.3d'
	1   ,q20,q30,q40,q50)
C		
	return
	end
